﻿//////////////////////////////////////////////
// ObjEncoder.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

#include "../Data/DecodedData.h"

#include "ObjDecodeOptions.h"

// nkMemory
#include <NilkinsMemory/Containers/BufferView.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ObjEncoder final
	{
		private :

			// Constructor, destructor
			ObjEncoder () = delete ;
			~ObjEncoder () = delete ;

		public :

			// Decoding
			static bool canDecode (const nkMemory::BufferView<>& sources) ;
			static DecodedData decode (const nkMemory::BufferView<>& sources, const ObjDecodeOptions& options = ObjDecodeOptions()) ;
	} ;
}